<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/memchr-2.5.0/src/memmem/rarebytes.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>rarebytes.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../memchr/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../memchr/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../memchr/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
</pre><pre class="rust"><code><span class="doccomment">/// A heuristic frequency based detection of rare bytes for substring search.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This detector attempts to pick out two bytes in a needle that are predicted</span>
<span class="doccomment">/// to occur least frequently. The purpose is to use these bytes to implement</span>
<span class="doccomment">/// fast candidate search using vectorized code.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// A set of offsets is only computed for needles of length 2 or greater.</span>
<span class="doccomment">/// Smaller needles should be special cased by the substring search algorithm</span>
<span class="doccomment">/// in use. (e.g., Use memchr for single byte needles.)</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Note that we use `u8` to represent the offsets of the rare bytes in a</span>
<span class="doccomment">/// needle to reduce space usage. This means that rare byte occurring after the</span>
<span class="doccomment">/// first 255 bytes in a needle will never be used.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">Debug</span>, <span class="ident">Default</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">struct</span> <span class="ident">RareNeedleBytes</span> {
    <span class="doccomment">/// The leftmost offset of the rarest byte in the needle, according to</span>
    <span class="doccomment">/// pre-computed frequency analysis. The &quot;leftmost offset&quot; means that</span>
    <span class="doccomment">/// rare1i &lt;= i for all i where needle[i] == needle[rare1i].</span>
    <span class="ident">rare1i</span>: <span class="ident">u8</span>,
    <span class="doccomment">/// The leftmost offset of the second rarest byte in the needle, according</span>
    <span class="doccomment">/// to pre-computed frequency analysis. The &quot;leftmost offset&quot; means that</span>
    <span class="doccomment">/// rare2i &lt;= i for all i where needle[i] == needle[rare2i].</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The second rarest byte is used as a type of guard for quickly detecting</span>
    <span class="doccomment">/// a mismatch if the first byte matches. This is a hedge against</span>
    <span class="doccomment">/// pathological cases where the pre-computed frequency analysis may be</span>
    <span class="doccomment">/// off. (But of course, does not prevent *all* pathological cases.)</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// In general, rare1i != rare2i by construction, although there is no hard</span>
    <span class="doccomment">/// requirement that they be different. However, since the case of a single</span>
    <span class="doccomment">/// byte needle is handled specially by memchr itself, rare2i generally</span>
    <span class="doccomment">/// always should be different from rare1i since it would otherwise be</span>
    <span class="doccomment">/// ineffective as a guard.</span>
    <span class="ident">rare2i</span>: <span class="ident">u8</span>,
}

<span class="kw">impl</span> <span class="ident">RareNeedleBytes</span> {
    <span class="doccomment">/// Create a new pair of rare needle bytes with the given offsets. This is</span>
    <span class="doccomment">/// only used in tests for generating input data.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">test</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>))]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">rare1i</span>: <span class="ident">u8</span>, <span class="ident">rare2i</span>: <span class="ident">u8</span>) -&gt; <span class="ident">RareNeedleBytes</span> {
        <span class="ident">RareNeedleBytes</span> { <span class="ident">rare1i</span>, <span class="ident">rare2i</span> }
    }

    <span class="doccomment">/// Detect the leftmost offsets of the two rarest bytes in the given</span>
    <span class="doccomment">/// needle.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">forward</span>(<span class="ident">needle</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">RareNeedleBytes</span> {
        <span class="kw">if</span> <span class="ident">needle</span>.<span class="ident">len</span>() <span class="op">&lt;</span><span class="op">=</span> <span class="number">1</span> <span class="op">|</span><span class="op">|</span> <span class="ident">needle</span>.<span class="ident">len</span>() <span class="op">&gt;</span> <span class="ident">core::u8::MAX</span> <span class="kw">as</span> <span class="ident">usize</span> {
            <span class="comment">// For needles bigger than u8::MAX, our offsets aren&#39;t big enough.</span>
            <span class="comment">// (We make our offsets small to reduce stack copying.)</span>
            <span class="comment">// If you have a use case for it, please file an issue. In that</span>
            <span class="comment">// case, we should probably just adjust the routine below to pick</span>
            <span class="comment">// some rare bytes from the first 255 bytes of the needle.</span>
            <span class="comment">//</span>
            <span class="comment">// Also note that for needles of size 0 or 1, they are special</span>
            <span class="comment">// cased in Two-Way.</span>
            <span class="comment">//</span>
            <span class="comment">// TODO: Benchmar this.</span>
            <span class="kw">return</span> <span class="ident">RareNeedleBytes</span> { <span class="ident">rare1i</span>: <span class="number">0</span>, <span class="ident">rare2i</span>: <span class="number">0</span> };
        }

        <span class="comment">// Find the rarest two bytes. We make them distinct by construction.</span>
        <span class="kw">let</span> (<span class="kw-2">mut</span> <span class="ident">rare1</span>, <span class="kw-2">mut</span> <span class="ident">rare1i</span>) <span class="op">=</span> (<span class="ident">needle</span>[<span class="number">0</span>], <span class="number">0</span>);
        <span class="kw">let</span> (<span class="kw-2">mut</span> <span class="ident">rare2</span>, <span class="kw-2">mut</span> <span class="ident">rare2i</span>) <span class="op">=</span> (<span class="ident">needle</span>[<span class="number">1</span>], <span class="number">1</span>);
        <span class="kw">if</span> <span class="ident">rank</span>(<span class="ident">rare2</span>) <span class="op">&lt;</span> <span class="ident">rank</span>(<span class="ident">rare1</span>) {
            <span class="ident">core::mem::swap</span>(<span class="kw-2">&amp;mut</span> <span class="ident">rare1</span>, <span class="kw-2">&amp;mut</span> <span class="ident">rare2</span>);
            <span class="ident">core::mem::swap</span>(<span class="kw-2">&amp;mut</span> <span class="ident">rare1i</span>, <span class="kw-2">&amp;mut</span> <span class="ident">rare2i</span>);
        }
        <span class="kw">for</span> (<span class="ident">i</span>, <span class="kw-2">&amp;</span><span class="ident">b</span>) <span class="kw">in</span> <span class="ident">needle</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>().<span class="ident">skip</span>(<span class="number">2</span>) {
            <span class="kw">if</span> <span class="ident">rank</span>(<span class="ident">b</span>) <span class="op">&lt;</span> <span class="ident">rank</span>(<span class="ident">rare1</span>) {
                <span class="ident">rare2</span> <span class="op">=</span> <span class="ident">rare1</span>;
                <span class="ident">rare2i</span> <span class="op">=</span> <span class="ident">rare1i</span>;
                <span class="ident">rare1</span> <span class="op">=</span> <span class="ident">b</span>;
                <span class="ident">rare1i</span> <span class="op">=</span> <span class="ident">i</span> <span class="kw">as</span> <span class="ident">u8</span>;
            } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">b</span> <span class="op">!</span><span class="op">=</span> <span class="ident">rare1</span> <span class="op">&amp;&amp;</span> <span class="ident">rank</span>(<span class="ident">b</span>) <span class="op">&lt;</span> <span class="ident">rank</span>(<span class="ident">rare2</span>) {
                <span class="ident">rare2</span> <span class="op">=</span> <span class="ident">b</span>;
                <span class="ident">rare2i</span> <span class="op">=</span> <span class="ident">i</span> <span class="kw">as</span> <span class="ident">u8</span>;
            }
        }
        <span class="comment">// While not strictly required, we really don&#39;t want these to be</span>
        <span class="comment">// equivalent. If they were, it would reduce the effectiveness of</span>
        <span class="comment">// candidate searching using these rare bytes by increasing the rate of</span>
        <span class="comment">// false positives.</span>
        <span class="macro">assert_ne!</span>(<span class="ident">rare1i</span>, <span class="ident">rare2i</span>);
        <span class="ident">RareNeedleBytes</span> { <span class="ident">rare1i</span>, <span class="ident">rare2i</span> }
    }

    <span class="doccomment">/// Return the rare bytes in the given needle in the forward direction.</span>
    <span class="doccomment">/// The needle given must be the same one given to the RareNeedleBytes</span>
    <span class="doccomment">/// constructor.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">as_rare_bytes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">needle</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; (<span class="ident">u8</span>, <span class="ident">u8</span>) {
        (<span class="ident">needle</span>[<span class="self">self</span>.<span class="ident">rare1i</span> <span class="kw">as</span> <span class="ident">usize</span>], <span class="ident">needle</span>[<span class="self">self</span>.<span class="ident">rare2i</span> <span class="kw">as</span> <span class="ident">usize</span>])
    }

    <span class="doccomment">/// Return the rare offsets such that the first offset is always &lt;= to the</span>
    <span class="doccomment">/// second offset. This is useful when the caller doesn&#39;t care whether</span>
    <span class="doccomment">/// rare1 is rarer than rare2, but just wants to ensure that they are</span>
    <span class="doccomment">/// ordered with respect to one another.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">memchr_runtime_simd</span>)]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">as_rare_ordered_usize</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; (<span class="ident">usize</span>, <span class="ident">usize</span>) {
        <span class="kw">let</span> (<span class="ident">rare1i</span>, <span class="ident">rare2i</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">as_rare_ordered_u8</span>();
        (<span class="ident">rare1i</span> <span class="kw">as</span> <span class="ident">usize</span>, <span class="ident">rare2i</span> <span class="kw">as</span> <span class="ident">usize</span>)
    }

    <span class="doccomment">/// Like as_rare_ordered_usize, but returns the offsets as their native</span>
    <span class="doccomment">/// u8 values.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">memchr_runtime_simd</span>)]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">as_rare_ordered_u8</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; (<span class="ident">u8</span>, <span class="ident">u8</span>) {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">rare1i</span> <span class="op">&lt;</span><span class="op">=</span> <span class="self">self</span>.<span class="ident">rare2i</span> {
            (<span class="self">self</span>.<span class="ident">rare1i</span>, <span class="self">self</span>.<span class="ident">rare2i</span>)
        } <span class="kw">else</span> {
            (<span class="self">self</span>.<span class="ident">rare2i</span>, <span class="self">self</span>.<span class="ident">rare1i</span>)
        }
    }

    <span class="doccomment">/// Return the rare offsets as usize values in the order in which they were</span>
    <span class="doccomment">/// constructed. rare1, for example, is constructed as the &quot;rarer&quot; byte,</span>
    <span class="doccomment">/// and thus, callers may want to treat it differently from rare2.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">as_rare_usize</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; (<span class="ident">usize</span>, <span class="ident">usize</span>) {
        (<span class="self">self</span>.<span class="ident">rare1i</span> <span class="kw">as</span> <span class="ident">usize</span>, <span class="self">self</span>.<span class="ident">rare2i</span> <span class="kw">as</span> <span class="ident">usize</span>)
    }

    <span class="doccomment">/// Return the byte frequency rank of each byte. The higher the rank, the</span>
    <span class="doccomment">/// more frequency the byte is predicted to be. The needle given must be</span>
    <span class="doccomment">/// the same one given to the RareNeedleBytes constructor.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">as_ranks</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">needle</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; (<span class="ident">usize</span>, <span class="ident">usize</span>) {
        <span class="kw">let</span> (<span class="ident">b1</span>, <span class="ident">b2</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">as_rare_bytes</span>(<span class="ident">needle</span>);
        (<span class="ident">rank</span>(<span class="ident">b1</span>), <span class="ident">rank</span>(<span class="ident">b2</span>))
    }
}

<span class="doccomment">/// Return the heuristical frequency rank of the given byte. A lower rank</span>
<span class="doccomment">/// means the byte is believed to occur less frequently.</span>
<span class="kw">fn</span> <span class="ident">rank</span>(<span class="ident">b</span>: <span class="ident">u8</span>) -&gt; <span class="ident">usize</span> {
    <span class="ident"><span class="kw">crate</span>::memmem::byte_frequencies::BYTE_FREQUENCIES</span>[<span class="ident">b</span> <span class="kw">as</span> <span class="ident">usize</span>] <span class="kw">as</span> <span class="ident">usize</span>
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="memchr" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>